#!/bin/sh 

# Soll das Script eine Vollzugsmeldung auf der gesperrten Box anzeigen ? Dann tragen sie fr Showaction ein 1 ein
# Die FB wird nicht gesperrt, wenn auf der anderen Box die Webapi nicht reagiert. Diese Meldung erscheint dann immer.
ShowAction=1
PluginPath=/var/tuxbox/plugins/
ConfigPath=/var/tuxbox/config/
# Look for local Dbox IP
#IFS=" "  #Delimiter
while read PName PRest
do 
	if [ "$PName"  = "address" ]; then
		MyIP=$PRest
	fi;
done < /var/etc/network/interfaces

# IPRange = IP Adressbereich der durchsucht wird 
#Entweder hier anhand der BoxIp ermittelt
MyIP1=$(echo $MyIP | cut -f1 -d.) 
MyIP2=$(echo $MyIP | cut -f2 -d.)
MyIP3=$(echo $MyIP | cut -f3 -d.) 
MyIP4=$(echo $MyIP | cut -f4 -d.) 
IPRange=$MyIP1"."$MyIP2"."$MyIP3"."

# oder hier von Hand angegebene Werte nutzen  (Bsp: 192.168.100. Punkt am Schluss nicht vergessen) einfach das Doppelkreuz entfernen
#IPRange=192.168.000.
#BoxIP
#MyIP=192.168.000.x

#Vorgabe des Suchbereichs
#Beginne bei      Erste IP        Bsp: 192.168.100.95 = 95 Erste IP nach der gesucht wird.
CheckIPStart=22
#Und ende bei     Letzte Ip +1  Bsp: 192.168.100.103 wenn 102 die letzte Ip sein soll nach der gesucht wird.
CheckIPEnd=26

if [ -e "$ConfigPath"fb_change.conf ]; then
	echo "Configfile vorhanden, Loeschen und neues anlegen ? y/n"
	while [ "$createnewconf" -eq "0" ];
	do 
		read Userinput
		case $Userinput in
			y|Y|j|J )
				createnewconf=1
				echo "Configfile wird geloescht und neues angelegt"
				rm "$ConfigPath"fb_change.conf
			;;
			n|N )
				createnewconf=2
			;;
			* )
				echo "ich kann leider keine Gedanken lesen, bitte nur y/n/j/n eingeben"
			;;
		esac
	done
else
	createnewconf=1
fi;

if [ "$MyIP" -a "$createnewconf" = "1" ]; then
	echo "\nBoxIP gefunden, soll das komplette Subnetz gescannt werden ? y/n"
	echo "\nWenn hier nein angegeben wird sollten in der Datei" 
	echo "$ConfigPath"fb_change.conf""
	echo "schon die IP Adressen der Dboxen eingetragen sein, oder zumindest"
	echo "der IP Bereich der durchsucht werden soll, hier im Script angegeben sein."
	echo "Sonst werden vieleicht keine DBoxen gefunden."
	echo "Da das Script ohne Aenderungen sonst nur den Bereich von"
	echo "$IPRange$CheckIPStart bis $IPRange$CheckIPEnd durchsucht."
	echo	"\nMoechten sie das komplette Subnetz scannen lassen ? y/n"
	echo "Dies kann sehr lange dauern !"
	while [ "$subnetzscan" -eq "0" ];
	do 
		read Userinput
		case $Userinput in
			y|Y|j|J )
				subnetzscan=1
				CheckIPStart=1
				CheckIPEnd=255
				echo "Komplettes Subnetz wird gescannt"
				echo "Scanbereich von IP $IPRange$CheckIPStart bis $IPRange$CheckIPEnd"
			;;
			n|N )
				subnetzscan=2
				echo "Teilbereich im Subnetz wird gescannt"
				echo "Scanbereich von IP $IPRange$CheckIPStart bis $IPRange$CheckIPEnd"
			;;
			* )
				echo "ich kann leider keine Gedanken lesen, bitte nur y/n/j/n eingeben"
			;;
		esac
	done
fi;


if [ "$createnewconf" = "1" ]; then				
	#Look for other Dbox IPs in IPRange
	while [ "$CheckIPStart" -lt "$CheckIPEnd" ]
	do
		echo "\nPruefe "$IPRange$CheckIPStart
		ping -q -c 1 $IPRange$CheckIPStart > /dev/null
		if [ $? -eq 0 ]; then 
			wget -q http://$IPRange$CheckIPStart/control/rc -O /dev/null
			if [ $? -eq 0 ]; then 
				echo "Found Box at $IPRange$CheckIPStart"
				if [ "$IPRange$CheckIPStart" != "$MyIP" ]; then
					echo "$IPRange$CheckIPStart" >> "$ConfigPath"fb_change.conf
				else
					echo "Eigene Box gefunden, wird nicht eingetragen."
				fi;
			else
				echo "IP $IPRange$CheckIPStart reagiert, aber vermutlich keine Box"
			fi;
		else
			echo "IP $IPRange$CheckIPStart reagiert nicht"	
		fi;
		CheckIPStart=`expr $CheckIPStart + 1`
	done
fi;

if [ -e "$ConfigPath"fb_change.conf ]; then
	while read OtherBoxIP
	do 
		echo "\nBearbeite cfg File fuer "$OtherBoxIP
		cfg_file="$PluginPath""multi_fb_"$OtherBoxIP".cfg"
		echo "type=3" > $cfg_file
		echo "name=Aktiviere FB auf Box $OtherBoxIP" >> $cfg_file
		echo "desc=Sperrt die FB und gibt sie auf Box $OtherBoxIP frei." >> $cfg_file
		echo "needfb=0" >> $cfg_file
		echo "needrc=0" >> $cfg_file
		echo "needvtxtpid=0" >> $cfg_file
		echo "needoffsets=0" >> $cfg_file
	
		echo "Bearbeite Scriptfile fuer "$OtherBoxIP
		script_file="$PluginPath""multi_fb_"$OtherBoxIP".sh"
		echo "#!/bin/sh" >$script_file
		echo "#" >> $script_file
		echo "#" >> $script_file
		echo "# Check if OtherBoxIp is a DBOX2 and Webapi is operational, If not then exit Script" >> $script_file
		echo "wget -q http://$OtherBoxIP/control/rc -O /dev/null" >> $script_file
		echo "if [ \$? -eq 1 ]; then " >> $script_file
		echo "     echo \"Fehler mit OtherBoxIP $OtherBoxIP\"" >> $script_file
		echo "     echo \"Box aus oder Webapi Problem (keine DBox2 ?)\"" >> $script_file
		echo "     echo \"FB wird daher nicht gesperrt\"" >> $script_file
		echo "     exit 1" >> $script_file
		echo "fi;" >> $script_file
		echo "# Block FB on MyIP and Free FB on OtherBoxIP" >> $script_file
		echo "wget -q http://$MyIP/control/rc?lock -O /dev/null" >> $script_file
		echo "wget -q http://$OtherBoxIP/control/rc?unlock -O /dev/null" >> $script_file
		if [ "$ShowAction" = "1" ]; then
			echo "# Output Explanation" >> $script_file
			echo "echo \"FB per Script fuer $MyIP gesperrt und\" " >> $script_file
			echo "echo \"fuer $OtherBoxIP freigegeben\"" >> $script_file
		fi;
		echo "exit 0" >> $script_file

		chmod 755 $script_file
	done < "$ConfigPath"fb_change.conf
else
	echo "Es wurden keine IP Adressen in der Datei"
	echo "$ConfigPath"fb_change.conf" gefunden!"
	echo "Haben sie dem Script erlaubt die Datei"
	echo "$ConfigPath"fb_change.conf" neu zu erstellen ?"
	echo "Dann wurden vermutlich keine aktiven Boxen im Scanbereich entdeckt."
	echo "Daher wurde auch kein FB Script erstellt."
fi;

echo "\nScriptbearbeitung Fertig"
exit 0